diff --git a/lib/libssh/config.h b/lib/libssh/config.h
index a1cc77beaa..529887a056 100644
--- a/lib/libssh/config.h
+++ b/lib/libssh/config.h
@@ -464,7 +464,7 @@
 #define HAVE_ECDSA_SIG_SET0 1
 
 /* Define to 1 if you have the `EC_KEY_METHOD_new' function. */
-#define HAVE_EC_KEY_METHOD_NEW 1
+/* #undef HAVE_EC_KEY_METHOD_NEW */
 
 /* Define to 1 if you have the <elf.h> header file. */
 #define HAVE_ELF_H 1
@@ -500,19 +500,19 @@
 #define HAVE_EVP_CIPHER_CTX_CTRL 1
 
 /* Define to 1 if you have the `EVP_CIPHER_CTX_get_iv' function. */
-#define HAVE_EVP_CIPHER_CTX_GET_IV 1
+/* #undef HAVE_EVP_CIPHER_CTX_GET_IV */
 
 /* Define to 1 if you have the `EVP_CIPHER_CTX_get_updated_iv' function. */
-/* #undef HAVE_EVP_CIPHER_CTX_GET_UPDATED_IV */
+#define HAVE_EVP_CIPHER_CTX_GET_UPDATED_IV 1
 
 /* Define to 1 if you have the `EVP_CIPHER_CTX_iv' function. */
-/* #undef HAVE_EVP_CIPHER_CTX_IV */
+#define HAVE_EVP_CIPHER_CTX_IV 1
 
 /* Define to 1 if you have the `EVP_CIPHER_CTX_iv_noconst' function. */
-/* #undef HAVE_EVP_CIPHER_CTX_IV_NOCONST */
+#define HAVE_EVP_CIPHER_CTX_IV_NOCONST 1
 
 /* Define to 1 if you have the `EVP_CIPHER_CTX_set_iv' function. */
-#define HAVE_EVP_CIPHER_CTX_SET_IV 1
+/* #undef HAVE_EVP_CIPHER_CTX_SET_IV */
 
 /* Define to 1 if you have the `EVP_DigestFinal_ex' function. */
 #define HAVE_EVP_DIGESTFINAL_EX 1
@@ -521,7 +521,7 @@
 #define HAVE_EVP_DIGESTINIT_EX 1
 
 /* Define to 1 if you have the `EVP_MD_CTX_cleanup' function. */
-#define HAVE_EVP_MD_CTX_CLEANUP 1
+/* #undef HAVE_EVP_MD_CTX_CLEANUP */
 
 /* Define to 1 if you have the `EVP_MD_CTX_copy_ex' function. */
 #define HAVE_EVP_MD_CTX_COPY_EX 1
@@ -530,7 +530,7 @@
 #define HAVE_EVP_MD_CTX_FREE 1
 
 /* Define to 1 if you have the `EVP_MD_CTX_init' function. */
-#define HAVE_EVP_MD_CTX_INIT 1
+/* #undef HAVE_EVP_MD_CTX_INIT */
 
 /* Define to 1 if you have the `EVP_MD_CTX_new' function. */
 #define HAVE_EVP_MD_CTX_NEW 1
@@ -767,7 +767,7 @@
 #define HAVE_HEADER_AD 1
 
 /* Define to 1 if you have the `HMAC_CTX_init' function. */
-#define HAVE_HMAC_CTX_INIT 1
+/* #undef HAVE_HMAC_CTX_INIT */
 
 /* Define if you have ut_host in utmp.h */
 /* #undef HAVE_HOST_IN_UTMP */
diff --git a/lib/libssh/openbsd-compat/openssl-compat.c b/lib/libssh/openbsd-compat/openssl-compat.c
index a37ca61bf2..83b5747d95 100644
--- a/lib/libssh/openbsd-compat/openssl-compat.c
+++ b/lib/libssh/openbsd-compat/openssl-compat.c
@@ -93,4 +93,62 @@ ssh_libcrypto_init(void)
 #endif /* USE_OPENSSL_ENGINE */
 }
 
+#ifndef HAVE_EVP_CIPHER_CTX_GET_IV
+int
+EVP_CIPHER_CTX_get_iv(const EVP_CIPHER_CTX *ctx, unsigned char *iv, size_t len)
+{
+	if (ctx == NULL)
+		return 0;
+	if (EVP_CIPHER_CTX_iv_length(ctx) < 0)
+		return 0;
+	if (len != (size_t)EVP_CIPHER_CTX_iv_length(ctx))
+		return 0;
+	if (len > EVP_MAX_IV_LENGTH)
+		return 0; /* sanity check; shouldn't happen */
+	/*
+	 * Skip the memcpy entirely when the requested IV length is zero,
+	 * since the iv pointer may be NULL or invalid.
+	 */
+	if (len != 0) {
+		if (iv == NULL)
+			return 0;
+# ifdef HAVE_EVP_CIPHER_CTX_IV
+		memcpy(iv, EVP_CIPHER_CTX_iv(ctx), len);
+# else
+		memcpy(iv, ctx->iv, len);
+# endif /* HAVE_EVP_CIPHER_CTX_IV */
+	}
+	return 1;
+}
+#endif /* HAVE_EVP_CIPHER_CTX_GET_IV */
+
+#ifndef HAVE_EVP_CIPHER_CTX_SET_IV
+int
+EVP_CIPHER_CTX_set_iv(EVP_CIPHER_CTX *ctx, const unsigned char *iv, size_t len)
+{
+	if (ctx == NULL)
+		return 0;
+	if (EVP_CIPHER_CTX_iv_length(ctx) < 0)
+		return 0;
+	if (len != (size_t)EVP_CIPHER_CTX_iv_length(ctx))
+		return 0;
+	if (len > EVP_MAX_IV_LENGTH)
+		return 0; /* sanity check; shouldn't happen */
+	/*
+	 * Skip the memcpy entirely when the requested IV length is zero,
+	 * since the iv pointer may be NULL or invalid.
+	 */
+	if (len != 0) {
+		if (iv == NULL)
+			return 0;
+# ifdef HAVE_EVP_CIPHER_CTX_IV_NOCONST
+		memcpy(EVP_CIPHER_CTX_iv_noconst(ctx), iv, len);
+# else
+		memcpy(ctx->iv, iv, len);
+# endif /* HAVE_EVP_CIPHER_CTX_IV_NOCONST */
+	}
+	return 1;
+}
+#endif /* HAVE_EVP_CIPHER_CTX_SET_IV */
+
 #endif /* WITH_OPENSSL */
diff --git a/lib/libssh/openbsd-compat/openssl-compat.h b/lib/libssh/openbsd-compat/openssl-compat.h
index 25638ef827..87d85d8b9f 100644
--- a/lib/libssh/openbsd-compat/openssl-compat.h
+++ b/lib/libssh/openbsd-compat/openssl-compat.h
@@ -46,5 +46,15 @@ void ssh_libcrypto_init(void);
 # define OPENSSL_DSA_MAX_MODULUS_BITS	10000
 #endif
 
+#ifndef HAVE_EVP_CIPHER_CTX_GET_IV
+int EVP_CIPHER_CTX_get_iv(const EVP_CIPHER_CTX *ctx,
+    unsigned char *iv, size_t len);
+#endif /* HAVE_EVP_CIPHER_CTX_GET_IV */
+
+#ifndef HAVE_EVP_CIPHER_CTX_SET_IV
+int EVP_CIPHER_CTX_set_iv(EVP_CIPHER_CTX *ctx,
+    const unsigned char *iv, size_t len);
+#endif /* HAVE_EVP_CIPHER_CTX_SET_IV */
+
 #endif /* WITH_OPENSSL */
 #endif /* _OPENSSL_COMPAT_H */
diff --git a/lib/libssl/Makefile b/lib/libssl/Makefile
new file mode 100644
index 0000000000..7dc39cf3fe
--- /dev/null
+++ b/lib/libssl/Makefile
@@ -0,0 +1,45 @@
+LIB=		private_ssl
+SHLIB_MAJOR=	49
+PRIVATELIB=	shpub
+SHLIBDIR?=	/lib
+
+WARNS?=		2
+
+OPENSSL_SRC=	${.CURDIR}/../../crypto/openssl
+
+.PATH:	${OPENSSL_SRC}/include/openssl \
+	${OPENSSL_SRC}/ssl \
+	${OPENSSL_SRC}/ssl/record \
+	${OPENSSL_SRC}/ssl/statem
+
+# base sources
+SRCS=	bio_ssl.c d1_lib.c d1_msg.c d1_srtp.c methods.c pqueue.c s3_enc.c \
+	s3_lib.c s3_msg.c ssl_asn1.c ssl_cert.c ssl_ciph.c ssl_conf.c \
+	ssl_err.c ssl_err_legacy.c ssl_init.c ssl_lib.c ssl_mcnf.c ssl_rsa.c \
+	ssl_rsa_legacy.c ssl_sess.c ssl_stat.c ssl_txt.c ssl_utst.c t1_enc.c \
+	t1_lib.c t1_trce.c tls13_enc.c tls_depr.c tls_srp.c
+
+# record
+SRCS+=	dtls1_bitmap.c rec_layer_d1.c rec_layer_s3.c ssl3_buffer.c \
+	ssl3_record.c ssl3_record_tls13.c
+
+# statem
+SRCS+=	extensions.c extensions_clnt.c extensions_cust.c extensions_srvr.c \
+	statem.c statem_clnt.c statem_dtls.c statem_lib.c statem_srvr.c
+
+CFLAGS+=-DAES_ASM \
+	-Wa,--noexecstack \
+	-DL_ENDIAN \
+	${PRIVATELIB_CFLAGS} \
+	-I${OPENSSL_SRC} \
+	-I${OPENSSL_SRC}/include \
+	-DOPENSSLDIR="\"/etc/ssl\""
+
+INCS=	dtls1.h prov_ssl.h srtp.h ssl.h sslerr.h sslerr_legacy.h ssl2.h \
+	ssl3.h tls1.h
+INCSDIR=${INCLUDEDIR}/priv/openssl
+
+DPADD=	${LIBPTHREAD}
+LDADD=	-lpthread
+
+.include <bsd.lib.mk>
diff --git a/lib/libtcplay/Makefile b/lib/libtcplay/Makefile
index 65f158f93c..104710a34e 100644
--- a/lib/libtcplay/Makefile
+++ b/lib/libtcplay/Makefile
@@ -19,7 +19,7 @@ MLINKS+=	tcplay.3	tc_api_task_get_error.3
 
 CFLAGS+=	-DMAJ_VER=${MAJ_VER} -DMIN_VER=${MIN_VER}
 CFLAGS+=	-D_FILE_OFFSET_BITS=64
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 SRCS+=		tcplay.c crc32.c safe_mem.c io.c hdr.c humanize.c
 SRCS+=		crypto.c generic_xts.c
diff --git a/lib/libtelnet/Makefile b/lib/libtelnet/Makefile
index 580f41111b..cbb586ac34 100644
--- a/lib/libtelnet/Makefile
+++ b/lib/libtelnet/Makefile
@@ -10,7 +10,8 @@ SRCS=		auth.c enc_des.c encrypt.c genget.c getent.c misc.c sra.c pk.c
 WARNS?=		2
 
 CFLAGS+=	-DENCRYPTION -DAUTHENTICATION -DSRA
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 .if defined(RESCUE)
 CFLAGS+=	-DNOPAM
diff --git a/lib/libtelnet/pk.c b/lib/libtelnet/pk.c
index 8ef55f1906..0b028e3f5b 100644
--- a/lib/libtelnet/pk.c
+++ b/lib/libtelnet/pk.c
@@ -175,7 +175,6 @@ itobn(long i)
 	if ((n = BN_new()) == NULL)
 		errx(1, "could not create BIGNUM: %s",
 		     ERR_error_string(ERR_get_error(), 0));
-	BN_init(n);
 	if (i > 0)
 		BN_add_word(n, (u_long)i);
 	else
diff --git a/libexec/dma/dma-mbox-create/Makefile b/libexec/dma/dma-mbox-create/Makefile
index 4a372047e6..57bbf22e7c 100644
--- a/libexec/dma/dma-mbox-create/Makefile
+++ b/libexec/dma/dma-mbox-create/Makefile
@@ -4,7 +4,7 @@ CFLAGS+=-I${.CURDIR}/..
 CFLAGS+= -DHAVE_REALLOCF -DHAVE_STRLCPY -DHAVE_GETPROGNAME
 CFLAGS+=-DCONF_PATH='"/etc/dma"'
 CFLAGS+=-DLIBEXEC_PATH='"/usr/libexec"' -DDMA_VERSION='"v0.13+"'
-CFLAGS+=-I${.CURDIR}/../../../crypto/libressl/include
+CFLAGS+=-I${.CURDIR}/../../../crypto/openssl/include
 
 PROG=	dma-mbox-create
 NOMAN=
diff --git a/libexec/dma/dma/Makefile b/libexec/dma/dma/Makefile
index 51ae9ae932..cce336f466 100644
--- a/libexec/dma/dma/Makefile
+++ b/libexec/dma/dma/Makefile
@@ -13,7 +13,8 @@ CFLAGS+=	-DLIBEXEC_PATH='"/usr/libexec"' -DDMA_VERSION='"v0.13+"'
 DPADD=		${LIBSSL} ${LIBCRYPTO}
 LDADD=		-lprivate_ssl -lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 BINOWN= root
 BINGRP= mail
diff --git a/libexec/ftpd/Makefile b/libexec/ftpd/Makefile
index 179893fdb7..1dceaa6ca4 100644
--- a/libexec/ftpd/Makefile
+++ b/libexec/ftpd/Makefile
@@ -35,6 +35,7 @@ LDFLAGS+= ${LDFLAGSPAM}
 CFLAGS+= -DNOMD5
 .else
 SRCS+= site_md5.c
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
diff --git a/libexec/sftp-server/Makefile b/libexec/sftp-server/Makefile
index 1ed713c46d..d65ddc849a 100644
--- a/libexec/sftp-server/Makefile
+++ b/libexec/sftp-server/Makefile
@@ -8,7 +8,7 @@ MAN=	sftp-server.8
 WARNS?=	3
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/libexec/ssh-keysign/Makefile b/libexec/ssh-keysign/Makefile
index 664271cdbf..f58d29792b 100644
--- a/libexec/ssh-keysign/Makefile
+++ b/libexec/ssh-keysign/Makefile
@@ -16,7 +16,7 @@ CFLAGS+= -DXAUTH_PATH=\"${XAUTH_PATH}\"
 .endif
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/libexec/ssh-pkcs11-helper/Makefile b/libexec/ssh-pkcs11-helper/Makefile
index 479ca9255e..e5cf6e7f68 100644
--- a/libexec/ssh-pkcs11-helper/Makefile
+++ b/libexec/ssh-pkcs11-helper/Makefile
@@ -11,7 +11,7 @@ WARNS=	3
 .PATH: ${.CURDIR}/../../crypto/openssh
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/libexec/telnetd/Makefile b/libexec/telnetd/Makefile
index 30d4d4745c..734f9509cc 100644
--- a/libexec/telnetd/Makefile
+++ b/libexec/telnetd/Makefile
@@ -26,7 +26,7 @@ LDFLAGS+=	${PRIVATELIB_LDFLAGS}
 CFLAGS+=	-I${_SHLIBDIRPREFIX}/usr/include/priv/ncurses
 
 CFLAGS+=	-DAUTHENTICATION -DENCRYPTION
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD+=		${LIBCRYPTO} ${LIBCRYPT} ${LIBPAM}
 LDADD+=		-lprivate_crypto -lcrypt ${MINUSLPAM}
 
diff --git a/sbin/cryptdisks/Makefile b/sbin/cryptdisks/Makefile
index 3af45a0ea9..47e8ea58ee 100644
--- a/sbin/cryptdisks/Makefile
+++ b/sbin/cryptdisks/Makefile
@@ -4,13 +4,13 @@ NOSHARED=	YES
 
 SRCS+=		cryptdisks.c safe_mem.c
 
-LDADD=		-lcryptsetup -lluks -ldm -ltcplay -lprop -lutil
+LDADD=		-lcryptsetup -lluks -ldm -ltcplay -lprop -lutil -lpthread
 DPADD=		${LIBCRYPTSETUP} ${LIBLUKS} ${LIBDM} ${LIBTCPLAY}
-DPADD+=		${LIBPROP} ${LIBUTIL}
+DPADD+=		${LIBPROP} ${LIBUTIL} ${LIBPTHREAD}
 
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 .include <bsd.prog.mk>
diff --git a/sbin/dhcpcd/Makefile b/sbin/dhcpcd/Makefile
index b0bd2a3d19..3ced7dd380 100644
--- a/sbin/dhcpcd/Makefile
+++ b/sbin/dhcpcd/Makefile
@@ -41,6 +41,7 @@ SRCS+=		hmac.c
 CFLAGS+=	-DUSE_PRIVATECRYPTO
 FLAGS_GROUPS=	openssl
 openssl_FLAGS=	-I${_SHLIBDIRPREFIX}/usr/include/priv/openssl
+openssl_FLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 openssl_FLAGS+=	-DMD5Init=MD5_Init -DMD5Update=MD5_Update -DMD5Final=MD5_Final
 openssl_FLAGS_FILES= hmac.c ipv6.c
 
diff --git a/sbin/fsck_hammer2/Makefile b/sbin/fsck_hammer2/Makefile
index 823908d5cf..ff75301687 100644
--- a/sbin/fsck_hammer2/Makefile
+++ b/sbin/fsck_hammer2/Makefile
@@ -5,6 +5,8 @@ MAN=  fsck_hammer2.8
 CFLAGS+= -I${.CURDIR}/../../sys -I${.CURDIR}/../hammer2
 CFLAGS+= -DXXH_NAMESPACE=h2_
 CFLAGS+= -DHAMMER2_USE_OPENSSL
+CFLAGS+= -DOPENSSL_SUPPRESS_DEPRECATED
+
 CFLAGS+= ${PRIVATELIB_CFLAGS}
 
 DPADD=   ${LIBCRYPTO}
diff --git a/sbin/hammer/Makefile b/sbin/hammer/Makefile
index 4d4bfe9911..090de698eb 100644
--- a/sbin/hammer/Makefile
+++ b/sbin/hammer/Makefile
@@ -10,6 +10,7 @@ SRCS=	hammer.c ondisk.c blockmap.c cache.c misc.c cycle.c uuid.c \
 MAN=	hammer.8
 
 CFLAGS+= -I${.CURDIR}/../../sys
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD=		${LIBM} ${LIBUTIL} ${LIBHAMMER} ${LIBCRYPTO}
 LDADD=		-lm -lutil -lhammer -lprivate_crypto
diff --git a/sbin/hammer2/Makefile b/sbin/hammer2/Makefile
index 30b0b71dc5..e5aec8e241 100644
--- a/sbin/hammer2/Makefile
+++ b/sbin/hammer2/Makefile
@@ -11,6 +11,7 @@ MAN=	hammer2.8
 CFLAGS+= -DXXH_NAMESPACE=h2_
 CFLAGS+= -I${.CURDIR}/../../sys
 CFLAGS+= -pthread
+CFLAGS+= -DOPENSSL_SUPPRESS_DEPRECATED
 
 DPADD=	${LIBDMSG} ${LIBM} ${LIBUTIL}
 LDADD=	-ldmsg -lm -lutil
diff --git a/sbin/iscontrol/Makefile b/sbin/iscontrol/Makefile
index 72735d17c5..1c0f678170 100644
--- a/sbin/iscontrol/Makefile
+++ b/sbin/iscontrol/Makefile
@@ -2,6 +2,7 @@
 
 SRCS= iscontrol.c pdu.c fsm.c config.c login.c auth_subr.c misc.c
 PROG= iscontrol
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD=		${LIBCAM} ${LIBCRYPTO}
 LDADD=		-lcam -lprivate_crypto
diff --git a/sbin/md5/Makefile b/sbin/md5/Makefile
index d076a0dd6b..3ef6b37bff 100644
--- a/sbin/md5/Makefile
+++ b/sbin/md5/Makefile
@@ -13,6 +13,7 @@ MLINKS=	md5.1 rmd160.1 \
 	md5.1 sha256.1 \
 	md5.1 sha512.1
 
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
diff --git a/sbin/mount_hammer2/Makefile b/sbin/mount_hammer2/Makefile
index a743c5c2ad..7f81ff8c32 100644
--- a/sbin/mount_hammer2/Makefile
+++ b/sbin/mount_hammer2/Makefile
@@ -2,7 +2,7 @@ PROG=	mount_hammer2
 MAN=	mount_hammer2.8
 
 CFLAGS+= -I${.CURDIR}/../../sys
-CFLAGS+= -I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+= -I${.CURDIR}/../../crypto/openssl/include
 LDADD=  -lutil
 DPADD=  ${LIBUTIL}
 
diff --git a/sbin/ping6/Makefile b/sbin/ping6/Makefile
index 4f87e62051..2ae5726300 100644
--- a/sbin/ping6/Makefile
+++ b/sbin/ping6/Makefile
@@ -4,6 +4,7 @@ PROG=	ping6
 MAN=	ping6.8
 
 CFLAGS+=-DINET6 -DHAVE_POLL_H -DHAVE_ARC4RANDOM -DUSE_RFC3542
+CFLAGS+=-DOPENSSL_SUPPRESS_DEPRECATED
 
 BINOWN=	root
 BINMODE=4555
diff --git a/sbin/routed/Makefile b/sbin/routed/Makefile
index f340535ce2..6bc044a73c 100644
--- a/sbin/routed/Makefile
+++ b/sbin/routed/Makefile
@@ -5,6 +5,7 @@ SRCS=   if.c input.c main.c output.c parms.c radix.c rdisc.c table.c trace.c
 MAN=   routed.8
 SUBDIR= rtquery
 
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
diff --git a/sbin/routed/rtquery/Makefile b/sbin/routed/rtquery/Makefile
index 9409289945..6a98ff1638 100644
--- a/sbin/routed/rtquery/Makefile
+++ b/sbin/routed/rtquery/Makefile
@@ -4,6 +4,7 @@
 PROG=	rtquery
 MAN=	rtquery.8
 NO_WARRAY_BOUNDS=
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 LDADD=		-lprivate_crypto
diff --git a/sbin/tcplay/Makefile b/sbin/tcplay/Makefile
index 17bdc89ce5..0cdd09e13a 100644
--- a/sbin/tcplay/Makefile
+++ b/sbin/tcplay/Makefile
@@ -17,7 +17,7 @@ DPADD=		${LIBDM} ${LIBPROP} ${LIBUTIL}
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 CFLAGS+=	-I${TCPLAY_DIR}
 CFLAGS+=	-DMAJ_VER=${MAJ_VER} -DMIN_VER=${MIN_VER}
diff --git a/share/examples/etc/README.examples b/share/examples/etc/README.examples
index d6405793e1..9c53ab2d74 100644
--- a/share/examples/etc/README.examples
+++ b/share/examples/etc/README.examples
@@ -79,5 +79,4 @@ ssh/moduli		- default prime numbers for sshd(8)
 ssh/ssh_config		- default SSH client configuration
 ssh/sshd_config		- default SSH daemon configuration
 ssl/			- directory containing default ssl files
-ssl/cert.pem		- default certificate bundle
 ssl/openssl.cnf		- default certificate configuration
diff --git a/share/examples/ssl/Makefile b/share/examples/ssl/Makefile
index 05b24abf73..50989062ca 100644
--- a/share/examples/ssl/Makefile
+++ b/share/examples/ssl/Makefile
@@ -1,4 +1,4 @@
-.PATH: ${.CURDIR}/../../../crypto/libressl/apps/openssl
+.PATH: ${.CURDIR}/../../../crypto/openssl/apps
 
 NOOBJ=	noobj
 FILES=	cert.pem openssl.cnf
diff --git a/tools/tools/net80211/w00t/Makefile.inc b/tools/tools/net80211/w00t/Makefile.inc
index 84257f3abe..e784349220 100644
--- a/tools/tools/net80211/w00t/Makefile.inc
+++ b/tools/tools/net80211/w00t/Makefile.inc
@@ -9,7 +9,7 @@ LDFLAGS=	-L${W00T}
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../../../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../../../../crypto/openssl/include
 
 BINDIR=	/usr/local/bin
 CFLAGS+=	-g -I${W00T}
diff --git a/usr.bin/bdes/Makefile b/usr.bin/bdes/Makefile
index fcbd7ef5e8..e1dc1daacb 100644
--- a/usr.bin/bdes/Makefile
+++ b/usr.bin/bdes/Makefile
@@ -8,6 +8,7 @@ WARNS?=	2
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/chkey/Makefile b/usr.bin/chkey/Makefile
index e4e1f89c5d..7428fc78a9 100644
--- a/usr.bin/chkey/Makefile
+++ b/usr.bin/chkey/Makefile
@@ -11,6 +11,6 @@ LDADD=	-lrpcsvc
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/dc/Makefile b/usr.bin/dc/Makefile
index 63f051cb71..397eeacdf5 100644
--- a/usr.bin/dc/Makefile
+++ b/usr.bin/dc/Makefile
@@ -7,6 +7,7 @@ WARNS?=	2
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/dc/bcode.c b/usr.bin/dc/bcode.c
index 629e389b1f..13687385d3 100644
--- a/usr.bin/dc/bcode.c
+++ b/usr.bin/dc/bcode.c
@@ -388,7 +388,7 @@ split_number(const struct number *n, BIGNUM *i, BIGNUM *f)
 	bn_checkp(BN_copy(i, n->number));
 
 	if (n->scale == 0 && f != NULL)
-		bn_check(BN_zero(f));
+		bn_check(BN_set_word(f, 0));
 	else if (n->scale < sizeof(factors)/sizeof(factors[0])) {
 		rem = BN_div_word(i, factors[n->scale]);
 		if (f != NULL)
@@ -794,7 +794,7 @@ load(void)
 		v = stack_tos(&bmachine.reg[index]);
 		if (v == NULL) {
 			n = new_number();
-			bn_check(BN_zero(n->number));
+			bn_check(BN_set_word(n->number, 0));
 			push_number(n);
 		} else
 			push(stack_dup_value(v, &copy));
@@ -878,7 +878,7 @@ load_array(void)
 			v = frame_retrieve(stack, index);
 			if (v == NULL || v->type == BCODE_NONE ) {
 				n = new_number();
-				bn_check(BN_zero(n->number));
+				bn_check(BN_set_word(n->number, 0));
 				push_number(n);
 			}
 			else
diff --git a/usr.bin/dc/bcode.h b/usr.bin/dc/bcode.h
index bf4348b254..48565c66aa 100644
--- a/usr.bin/dc/bcode.h
+++ b/usr.bin/dc/bcode.h
@@ -21,6 +21,7 @@
 
 #include <sys/types.h>
 #include <openssl/bn.h>
+#include <crypto/bn/bn_local.h>
 
 
 struct number {
diff --git a/usr.bin/dc/inout.c b/usr.bin/dc/inout.c
index 69739c0f5e..032b2e75b5 100644
--- a/usr.bin/dc/inout.c
+++ b/usr.bin/dc/inout.c
@@ -188,7 +188,7 @@ readnumber(struct source *src, u_int base)
 	BN_ULONG	v;
 
 	n = new_number();
-	bn_check(BN_zero(n->number));
+	bn_check(BN_set_word(n->number, 0));
 
 	while ((ch = (*src->vtable->readchar)(src)) != EOF) {
 
@@ -325,19 +325,19 @@ printnumber(FILE *f, const struct number *b, u_int base)
 	stack_clear(&stack);
 	if (b->scale > 0) {
 		struct number	*num_base;
-		BIGNUM		mult, stop;
+		BIGNUM		*mult, *stop;
 
 		putcharwrap(f, '.');
 		num_base = new_number();
 		bn_check(BN_set_word(num_base->number, base));
-		BN_init(&mult);
-		bn_check(BN_one(&mult));
-		BN_init(&stop);
-		bn_check(BN_one(&stop));
-		scale_number(&stop, b->scale);
+		mult = BN_new();
+		bn_check(BN_one(mult));
+		stop = BN_new();
+		bn_check(BN_one(stop));
+		scale_number(stop, b->scale);
 
 		i = 0;
-		while (BN_cmp(&mult, &stop) < 0) {
+		while (BN_cmp(mult, stop) < 0) {
 			u_long	rem;
 
 			if (i && base > 16)
@@ -355,11 +355,11 @@ printnumber(FILE *f, const struct number *b, u_int base)
 			    int_part->number));
 			printwrap(f, p);
 			free(p);
-			bn_check(BN_mul_word(&mult, base));
+			bn_check(BN_mul_word(mult, base));
 		}
 		free_number(num_base);
-		BN_free(&mult);
-		BN_free(&stop);
+		BN_free(mult);
+		BN_free(stop);
 	}
 	flushwrap(f);
 	free_number(int_part);
diff --git a/usr.bin/drill/Makefile b/usr.bin/drill/Makefile
index ecee45593b..04e7921663 100644
--- a/usr.bin/drill/Makefile
+++ b/usr.bin/drill/Makefile
@@ -12,7 +12,7 @@ CFLAGS+=	-I${LDNSBASE}/ldns -I${LDNS} -I${LDNS}/drill
 
 LDADD=		-lprivate_ldns -lprivate_crypto
 DPADD=		${LIBLDNS} ${LIBCRYPTO}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/dsynth/Makefile b/usr.bin/dsynth/Makefile
index 803fc272af..35435ca030 100644
--- a/usr.bin/dsynth/Makefile
+++ b/usr.bin/dsynth/Makefile
@@ -23,6 +23,7 @@ DPADD+=		${LIBPTHREAD} ${LIBUTIL}
 
 # ncurses, md5, for DragonFlyBSD
 #
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=        -I${_SHLIBDIRPREFIX}/usr/include/priv/ncurses
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 LDFLAGS+=       ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/nc/Makefile b/usr.bin/nc/Makefile
index eb57558b9b..c8e4cc3a7a 100644
--- a/usr.bin/nc/Makefile
+++ b/usr.bin/nc/Makefile
@@ -1,30 +1,8 @@
-# This version of nc(1) is from LibreSSL
-.PATH: ${.CURDIR}/../../crypto/libressl/apps/nc
-.PATH: ${.CURDIR}/../../crypto/libressl/tls
+# $FreeBSD$
 
 PROG=	nc
 SRCS=	netcat.c atomicio.c socks.c
 
-# TLS block (no separate libtls.a)
-SRCS+=	tls_bio_cb.c	\
-	tls_client.c	\
-	tls_config.c	\
-	tls_conninfo.c	\
-	tls_keypair.c	\
-	tls_peer.c	\
-	tls_ocsp.c	\
-	tls_server.c	\
-	tls_util.c	\
-	tls_verify.c	\
-	tls.c
-
 WARNS?=	2
 
-CFLAGS+= -DLIBRESSL_INTERNAL
-CFLAGS+=-I${.CURDIR}/../../crypto/libressl/include
-
-DPADD=	${LIBCRYPTO} ${LIBSSL}
-LDADD=	-lprivate_ssl -lprivate_crypto
-LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-
 .include <bsd.prog.mk>
diff --git a/usr.bin/nc/atomicio.c b/usr.bin/nc/atomicio.c
new file mode 100644
index 0000000000..344ac63ab9
--- /dev/null
+++ b/usr.bin/nc/atomicio.c
@@ -0,0 +1,67 @@
+/* $OpenBSD: atomicio.c,v 1.11 2012/12/04 02:24:47 deraadt Exp $ */
+/*
+ * Copyright (c) 2006 Damien Miller. All rights reserved.
+ * Copyright (c) 2005 Anil Madhavapeddy. All rights reserved.
+ * Copyright (c) 1995,1999 Theo de Raadt.  All rights reserved.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <poll.h>
+#include <unistd.h>
+
+#include "atomicio.h"
+
+/*
+ * ensure all of data on socket comes through. f==read || f==vwrite
+ */
+size_t
+atomicio(ssize_t (*f) (int, void *, size_t), int fd, void *_s, size_t n)
+{
+	char *s = _s;
+	size_t pos = 0;
+	ssize_t res;
+	struct pollfd pfd;
+
+	pfd.fd = fd;
+	pfd.events = f == read ? POLLIN : POLLOUT;
+	while (n > pos) {
+		res = (f) (fd, s + pos, n - pos);
+		switch (res) {
+		case -1:
+			if (errno == EINTR)
+				continue;
+			if ((errno == EAGAIN) || (errno == ENOBUFS)) {
+				(void)poll(&pfd, 1, -1);
+				continue;
+			}
+			return 0;
+		case 0:
+			errno = EPIPE;
+			return pos;
+		default:
+			pos += (size_t)res;
+		}
+	}
+	return (pos);
+}
diff --git a/usr.bin/nc/atomicio.h b/usr.bin/nc/atomicio.h
new file mode 100644
index 0000000000..7bf5b25418
--- /dev/null
+++ b/usr.bin/nc/atomicio.h
@@ -0,0 +1,39 @@
+/* $OpenBSD: atomicio.h,v 1.2 2007/09/07 14:50:44 tobias Exp $ */
+
+/*
+ * Copyright (c) 2006 Damien Miller.  All rights reserved.
+ * Copyright (c) 1995,1999 Theo de Raadt.  All rights reserved.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _ATOMICIO_H
+#define _ATOMICIO_H
+
+/*
+ * Ensure all of data on socket comes through. f==read || f==vwrite
+ */
+size_t	atomicio(ssize_t (*)(int, void *, size_t), int, void *, size_t);
+
+#define vwrite (ssize_t (*)(int, void *, size_t))write
+
+#endif /* _ATOMICIO_H */
